"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const FirebaseBase_1 = __importDefault(require("./FirebaseBase"));
class Firebase extends FirebaseBase_1.default {
    constructor(options) {
        super({
            db: options.db
        });
        this.component = options.component;
        this.key = options.key;
        this.unsubscribe = () => 0;
    }
    async getOnce(func) {
        let data = await this.get();
        if (func && data) {
            data = await func(data);
        }
        this.component[this.key] = data;
        this.component.$forceUpdate();
    }
    sync(func) {
        this.unsubscribe = this.chain.onSnapshot(async (snapshot) => {
            let data = this.getDataFromSnapshot(snapshot);
            if (func && data) {
                data = await func(data);
            }
            this.component[this.key] = data;
            this.component.$forceUpdate();
        });
    }
}
exports.default = Firebase;
//# sourceMappingURL=FirebaseVue.js.map